/* -*- C++ -*-  */
#include "furui.h"

/*
*Ւ뒥ȒÒƒǒõג풥钥

  ᒥ⒥꒤򒥱ÒВ璥(3)

     1bitñ̒ΒԒʒÒƒ뒤Β,1bit1ĒΒɽ뒡
     2/3/5ΒܒՒ뒥ΒВݒȒ,钤ᒤ钳

*By Ryuji Matsumoto (matumoto@pluto.ai.kyutech.ac.jp)

   1999/10/12 ǒ

* ޒ풡SIZEג

Ւ뒥ǒõϒϒ 2 (SIZE-1)

* ˡ
2/3/5Βܒϒᒤ钥Ւ뒥ΒВݒȒ뒡

2/3/5Βǒܒ30029쒳璤꒤˒2/3/5
ܒ

  0,   1,  2,  3,  4,  5,  6,  7,  8,  9
  x    o   x   x   x   x   x   o   x   x

  10, 11, 12, 13, 14, 15, 16, 17, 18, 19
  x   o   x   o   x   x   x   o   x   o

  20, 21, 22, 23, 24, 25, 26, 27, 28, 29
  x   x   x   o   x   x   x   x   x   o

蒤Ò,ĒÒ

   (0)  30n+1
   (1)  30n+7
   (2)  30n+11
   (3)  30n+13
   (4)  30n+17
   (5)  30n+19
   (6)  30n+23
   (7)  30n+29

ΒߒĴْ뒡

*ᒥ⒥꒻Ȓђ̒˒Ēƒ

furui2.cc˒撤ْ,ᒥ⒥꒤30/8ܒͭ˒Ē뒡Òƒᒥ⒥꒻Ȓђ
byte뒤,
             
              SIZE/8/(30/8) = SIZE/30 [byte]

*/

class CBitMap235 : public CBitMap
{
  /* 
     2/3/5Βܒϒᒤ钥Ւ뒥ΒВݒȒ뒡
     235Βܒ̵뒤뒥钥
     */
protected:

  /* 2/3/5Βܒʒ0֒
     쒰ʒʒ,ɒߒؒ뒥ɒ쒥֒*/
  virtual unsigned long yomikae(unsigned long int p) const
  {
    int p0 = -1;

    /* 235Βǒ30 */
    switch(p % 30)
      {
      case 1:
	p0 = 0;break;
      case 7:
	p0 = 1;break;
      case 11:
	p0 = 2;break;
      case 13:
	p0 = 3;break;
      case 17:	
	p0 = 4;break;
      case 19:
	p0 = 5;break;
      case 23:
	p0 = 6;break;	
      case 29:
	p0 = 7;break;	
      default:
	return 0;	
      }

    return (p / 30) * 8 + (unsigned long int )p0;
  }

public:
  CBitMap235(unsigned long int a_size)
  {
    /* ɬbitΒג */
    unsigned long int aa_size =a_size/30;
    if(aa_size % 30 != 0)
      aa_size++;
    aa_size *= 8;

    CBitMap::init(aa_size);
  }

  /* 2/3/5ΒܒȒtrue(ǒ)֒뒡*/
  bool get(unsigned long int position) const
  {
    unsigned long int p0 = yomikae(position);

    if(p0 == 0)
      return true;
    else
      return CBitMap::get(p0);
  }

  /* 2/3/5Βܒʒ钤В⒤ʒ*/
  void set(unsigned long int position, bool stat)
  {
    unsigned long int p0 = yomikae(position);

    if(p0 != 0)
      CBitMap::set(p0,stat);
  }
};

#if 1
/* CBitMap235ΒǒŬ */
class CBitMap235opt : public CBitMap235
{
public:
  CBitMap235opt(unsigned long int a_size): CBitMap235(a_size)
    {
      /* DO NOTHING */
    }

protected:
  /* ƒ֒뒤ȒÒ,®*/

  unsigned long yomikae(unsigned long int p) const
    {
      int offset = yomikae_table[p%30];
      
      if(offset == -1)
	return 0;
      else
	return (p / 30) * 8 + (unsigned long int) offset;
    }
};

#endif

int main()
{
  unsigned long int i, j;

  //CBitMap235 array(SIZE);
  CBitMap235opt array(SIZE);

  array.all_clear(false);

  /* גϒ2,3,5Βܒϒ7钻ϒᒤ쒤В */
  for(i = 7; i < SIZE; i++)
    {
      if(array.get(i) == false)
	for(j = i * 2; j < SIZE; j+=i)
	  array.set(j, true);
    }

  /* גλ */
  cout << "2" << endl;
  cout << "3" << endl;
  cout << "5" << endl;

  for(i = 2; i < SIZE; i++)
    {
      if(array.get(i) == false)
	cout << i << endl;
    }

  return (EXIT_SUCCESS);
}


