/* -*- C++ -*-  */
/*
  ե륤Ȥäǿõץࡣ

   By Ryuji Matsumoto (matumoto@pluto.ai.kyutech.ac.jp)

   1999/10/10 Ǻ
*/

#include <iostream.h>
#include <stdlib.h>
#include <string.h>

#define BYTE_SIZE 8
#define K (1024UL)
#define M (K*K)
#define G (M*K)


class CBitMap
{
  /* 1bitȤǽʵ򰷤Υ饹

  ץ̤, ǿfalse, ǿtrueȤ  */

/* 饹 CBitMapΰϰϸ򤹤롣 ǥХåѡ*/
#define C_BIT_MAP_CHECK_ERROR

private:
  unsigned long int array_size;
  unsigned long int real_size;
  unsigned char *array;
  const unsigned char MASK = 1;

protected:

  void init(unsigned long int a_size)
  {
    if(sizeof(unsigned char) != 1)
      {
	/*
	  ¸ץࡣץunsigned char8bit(1byte)
	  ȲꤷƤ롣
	  */
	cerr << "Error!\n";
	exit(EXIT_FAILURE);
      }

    if(a_size == 0)
      {
	cerr << "Error!\n";
	exit(EXIT_FAILURE);
      }
    else
      real_size = a_size;

    array_size = real_size / BYTE_SIZE;

    if(real_size % BYTE_SIZE)
      array_size++;

    array = new unsigned char[array_size];
      
    if(array == NULL)
      {
	cerr << "Memory Error!\n";
	exit(EXIT_FAILURE);
      }
  }

  /* ѾѤΥߡ */
  CBitMap(void)
  {
  }

public:

  CBitMap(unsigned long int a_size)
    {
      init(a_size);
    }

  virtual ~CBitMap()
  {
    delete [] array;
  }

  void all_clear(bool stat)
  {
    unsigned char init;
    if(stat == true)
      init = ~0;
    else
      init = 0;

    memset(array, init, sizeof(unsigned char) * array_size);
  }

  
  bool get(unsigned long int position) const
    {
#ifdef C_BIT_MAP_CHECK_ERROR
      if(position >= real_size)
	{
	  cerr << "Out of Range!\n";
	  exit(EXIT_FAILURE);
	}
#endif

      unsigned char mask = MASK;
      unsigned long int d = position / BYTE_SIZE;
      unsigned long int m = position % BYTE_SIZE;
      
      /* ANSI C Ǥ,ե̤0λư̤*/
      if(m != 0) mask <<= m;

      if(array[d] & mask)
	return true;
      else
	return false;
    }
  
  void set(unsigned long int position, bool stat)
    {
#ifdef C_BIT_MAP_CHECK_ERROR
      if(position >= real_size)
	{
	  cerr << "Out of Range!\n";
	  exit(EXIT_FAILURE);
	}
#endif

      unsigned char mask = MASK;
      unsigned long int d = position / BYTE_SIZE;
      unsigned long int m = position % BYTE_SIZE;
      
      /* ANSI C Ǥ,ե̤0λư̤*/
      if(m != 0) mask <<= m;

      if(stat == true)
	array[d] |= mask;
      else
	array[d] &= (~mask);
    }
};

/* 235κ30 235̵ܿ뤹ơ֥*/
static const signed char yomikae_table[30]=
{-1, 0,-1,-1,-1,-1,-1, 1,-1,-1,
 -1, 2,-1, 3,-1,-1,-1, 4,-1, 5,
 -1,-1,-1, 6,-1,-1,-1,-1,-1, 7};
